# B21_inter.py

import sys
import string
import cl_b21

# ===================================
def is_maj(car):
	if string.find(string.ascii_uppercase,car) == -1: 
		return 0
	else:
		return 1

def help():
	print "-- Passer du mode chiffrement (C) a dechif. (D) "
	print "md"
	print "-- Passer du mode Avant (A), Arriere (R) "
	print "ar"
	print "-- avance un rotor (ici Voyel(V)/ Consonne(C)) "
	print "ag:V"
	print "-- avance une roue (ici la 1ere (0) [0,1,2,3]"
	print "aw:0"
	print "-- avance l'ensemble des roues "
	print "av"
	print "-- Recule l'ensemble des roues "
	print "re"
	print "-- Code une lettre (ici 'Y') "
	print "co:Y"
	print "-- HELP: help, EXIT: exit"

def shell(ch):
	global mode_cd, mode_ar, compteur
	print "====>", ch
	cmd = ch.split(":")

	if    cmd[0] == "co":
		if mode_ar == "R": return
		compteur = compteur + 1
		if mode_cd == "C":
			clair = cmd[1]
			crypto = c.cipher(clair)
			print "---> ", crypto
		else:
			crypto = cmd[1]
			clair = c.decipher(crypto)
			print "---> ", clair
	elif  cmd[0] == "md":
		if mode_cd == "C":
			mode_cd = "D"
		else:
			mode_cd = "C"
	elif  cmd[0] == "ar":
		if mode_ar == "A":
			mode_ar = "R"
		else:
			mode_ar = "A"
	elif  cmd[0] == "ag":
		if mode_ar == "A": return
		if cmd[1] == "V":
			c.rot_vow.advance()
		elif cmd[1] == "C":
			c.rot_con.advance()
	elif  cmd[0] == "aw":
		if mode_ar == "A": return
		c.w[ int(cmd[1]) ].turnClockwise()
	elif  cmd[0] == "av":
		if mode_ar == "R": return
		c.advance()
		compteur = compteur + 1
	elif  cmd[0] == "re":
		if mode_ar == "R": return
		compteur = compteur - 1
		c.goBack()

# ======================================================
c = cl_b21.B_21("r1base","r1vowel","r1conso",0 )
mode_cd="C"
mode_ar="A"
help()
ch_old = "help"
compteur = 0

while 1:
	print "B-21, mode(C|D): ", mode_cd ,
	print " , mode(A|R): ", mode_ar ,
	print " , Compteur: ", compteur, 
	print " , Clef: ",
	print c.rot_vow.getKey(),
	print c.rot_con.getKey(),
	for i in range(4):
		print c.w[i].getExternalKey(),
	print
		
	ch = raw_input("Commande ? ")
	if ch == "":
		ch = ch_old
	else:
		ch_old = ch

	print "====>", ch
	cmd = ch.split(":")

	if    cmd[0] == "help":
		help()
	elif  cmd[0] == "exit":
		break
	else:
		shell(ch)





