# b21a_gui.py
# * le B a BA : clavier et lampe
# * les boutons et actions correspondantes
# * le chiffrement 
# * le bouton recule: Ok, ajouter un bouton avance !!! (demi-bouton)
# * on ajoute les menus (on se base sur c446 GUI)
# * aide en ligne: scroll ou PDF
# * demarrage par un script .pyw
# * Une image GIF de fond [ou dessin] ???

#---------------------------------------------------------
from Tkinter import *
from tkMessageBox import *
from tkFileDialog import *
from scrolledtext import *
import string
import random
import platform
import os
import subprocess
import cl_b21
#---------------------------------------------------------
def dessine_touche( lettre, coord ):
    x = coord[0] 
    y = coord[1]
    item1 = ecran.create_oval( x,y,x+30,y+30,fill="white")
    item2 = ecran.create_text(x+15,y+15,tags=lettre,text=lettre,
        font=('courrier',12,'bold'),fill='black')
    clavier_rond[lettre] = item1
    clavier_text[lettre] = item2
    ecran.tag_bind(item2,'<Button-1>',onClic)
    ecran.tag_bind(item2,'<ButtonRelease-1>',onClicRelease)
#---------------------------------------------------------
def dessine_lampe( lettre, coord ):
    x = coord[0] 
    y = coord[1]
    ecran.create_oval( x,y,x+30,y+30,fill="grey")
    item = ecran.create_text(x+15,y+15,tags=lettre,text=lettre,
        font=('courrier',12,'bold'),fill='white')
    lampe[lettre]=item
#---------------------------------------------------------
def dessine_bouton( lettre, coord , hauteur ):
    x = coord[0] ; 
    y = coord[1]
    item = ecran.create_rectangle(x,y,x+15,y+hauteur,
        tags=lettre,fill="gold")
    ecran.tag_bind(item,'<Button-1>',onClicButton)
#---------------------------------------------------------
def onClicButton(evt):
    global cpt
    if mode_ar == "A": return
    ref = evt.widget.find_closest(evt.x, evt.y)
    tags = ecran.gettags(ref[0])
    if   tags[0] == "A":
        cpt = cpt - 1
        c.goBack()
        majAffichage()
    elif tags[0] == "I":
        cpt = cpt + 1
        c.advance()
        majAffichage()
    elif tags[0] == "B":
        c.w[0].turnClockwise()
        cleWheel[0].configure(text=c.w[0].getExternalKey())        
    elif tags[0] == "C":
        c.w[1].turnClockwise()
        cleWheel[1].configure(text=c.w[1].getExternalKey())        
    elif tags[0] == "D":
        c.w[2].turnClockwise()
        cleWheel[2].configure(text=c.w[2].getExternalKey())        
    elif tags[0] == "E":
        c.w[3].turnClockwise()
        cleWheel[3].configure(text=c.w[3].getExternalKey())        
    elif tags[0] == "F":
        c.rot_vow.advance()
        cleHRgauche.configure(text=c.rot_vow.getKey())
    elif tags[0] == "G":
        c.rot_con.advance()
        cleHRdroite.configure(text=c.rot_con.getKey())
    print "BOUTON",tags[0]
#---------------------------------------------------------
def modeChiffre():
    global mode_cd
    m = modecd.cget('text')
    if m == "C":
        mode_cd = "D"
        modecd.configure(text="D")
    else:
        mode_cd = "C"
        modecd.configure(text="C")
    print m
#---------------------------------------------------------
def modeAvant():
    global mode_ar
    m = modear.cget('text')
    if m == "A":
        mode_ar = "R"
        modear.configure(text="R")
    else:
        mode_ar = "A"
        modear.configure(text="A")
    print "bouton AR:",m
#---------------------------------------------------------
def touche_enfoncee(lettre):
    item = clavier_rond[lettre]
    ecran.itemconfig(item,fill='black')
    chiffre(lettre)
#---------------------------------------------------------
def touche_relachee(lettre):
    global lettre_crypto
    item = clavier_rond[lettre]
    ecran.itemconfig(item,fill='white')
    lampe_eteinte(lettre_crypto)
#---------------------------------------------------------
def lampe_allumee(lettre):
    item = lampe[lettre]
    ecran.itemconfig(item,fill='green')
#---------------------------------------------------------
def lampe_eteinte(lettre):
    item = lampe[lettre]
    ecran.itemconfig(item,fill='white')
#---------------------------------------------------------
def onKeyPress(evt):
    global une_touche_enfoncee
    if une_touche_enfoncee: return
    une_touche_enfoncee = 1
    lettre = evt.char.upper()
    for une_lettre in list(alphabet):
        if une_lettre == lettre:
            print ">>>(enfoncee)", lettre
            touche_enfoncee(lettre)
#---------------------------------------------------------
def onKeyRelease(evt):
    global une_touche_enfoncee
    une_touche_enfoncee = 0
    lettre = evt.char.upper()
    print ">>>(relachee)", lettre
    for une_lettre in list(alphabet):
        if une_lettre == lettre:
            touche_relachee(lettre)
#---------------------------------------------------------
def majAffichage():
    for i in range(4):
        cleWheel[i].configure(text=c.w[i].getExternalKey())        
    cleHRgauche.configure(text=c.rot_vow.getKey())
    cleHRdroite.configure(text=c.rot_con.getKey())
    compteur.configure(text=str("%04d" % (cpt)))
#---------------------------------------------------------
def save(nomFichier):
    global keymodified 
    #nomFichier = raw_input("Nom du fichier (config par defaut) ? ")
    if nomFichier == "":
        nomFichier = "config"
    try:
        f = open( nomFichier, "w" )
    except:
        showinfo("Error","Impossible to open file")
        print "ERROR: impossible to open file"
        return

    ch = c.rot_vow.getKey()
    f.write( ch + '\n' )
    ch = c.rot_con.getKey()    
    f.write( ch + '\n' )
    for i in range(4):
        ch = c.w[i].getExternalKey()
        f.write( ch + '\n' )
        
    for i in range(4):
        ch = c.w[i].getInternalKey()
        f.write( ch + '\n' )

    ch = c.plug_con.getAlpha()
    f.write( ch + '\n' )
    ch = c.plug_con.getAllPlugs()
    f.write( ch + '\n' )

    ch = c.plug_vow.getAlpha()
    f.write( ch + '\n' )
    ch = c.plug_vow.getAllPlugs()
    f.write( ch + '\n' )

    f.close()

    keymodified = 0
    print "====> Sauvegarde effectuee"

def restore(nomFichier):
    try:
        f = open( nomFichier, "r" )
    except:
        if nomFichier == "conf_b21" :
            return
        showinfo("Error","Impossible to open file")
        return

    try:
        c.zero()
        ch = f.readline().strip()
        c.rot_vow.setKey( ch )
        ch = f.readline().strip()
        c.rot_con.setKey( ch )
        for i in range(4):
            ch = f.readline().strip()
            c.w[i].setKey(ch)
        for i in range(4):
            ch = f.readline().strip()
            print ch
            lg = len(ch)
            for j in range(lg):
                if ch[j] != '_':
                    c.w[i].setPinsON( ch[j] )
        
        ch = f.readline().strip()
        c.plug_con.setAlpha(ch)
        ch = f.readline().strip()
        c.plug_con.setAllPlugs(ch)

        ch = f.readline().strip()
        c.plug_vow.setAlpha(ch)
        ch = f.readline().strip()
        c.plug_vow.setAllPlugs(ch)

    except:
        showinfo("Error","Impossible to read the file")
        menu_nouveau()
        return
    finally:
        f.close()

#---------------------------------------------------------
def chiffre_une(lettre):
    global lettre_crypto, cpt, textesaisie, texteresultat
    if mode_ar == "R": return
    if mode_cd == "C":
        lettre_crypto = c.cipher( lettre )
    else:
        lettre_crypto = c.decipher( lettre )
    print "++++(chiffre)", lettre, lettre_crypto
    textesaisie += lettre
    texteresultat += lettre_crypto
    cpt = cpt + 1

def chiffre(lettre):
    if mode_ar == "R": return
    chiffre_une(lettre)
    compteur.configure(text=str("%04d" % (cpt)))
    cleHRgauche.configure(text=c.rot_vow.getKey())
    cleHRdroite.configure(text=c.rot_con.getKey())
    for i in range(4):
        cleWheel[i].configure(text=c.w[i].getExternalKey())        
    lampe_allumee(lettre_crypto)
#---------------------------------------------------------
def onClic(evt):
    ref = evt.widget.find_closest(evt.x, evt.y)
    tags = ecran.gettags(ref[0])
    touche_enfoncee(tags[0])
#---------------------------------------------------------
def onClicRelease(evt):
    ref = evt.widget.find_closest(evt.x, evt.y)
    tags = ecran.gettags(ref[0])
    touche_relachee(tags[0])    
#---------------------------------------------------------
def lcopier(lab):
    lab.clipboard_clear()
    lab.clipboard_append(lab.cget('text'))
#---------------------------------------------------------
def ok_pins():
    global lesPins, win, keymodified
    for i in range(4):
        for j in range( len(lesPins[i]) ):
            relief = lesPins[i][j].cget('relief')
            lettre = lesPins[i][j].cget('text')
            if relief == 'flat':
                c.w[i].setPinsON( lettre)
            else:
                c.w[i].setPinsOFF(lettre)
    keymodified = 1
    win.destroy()

#---------------------------------------------------------
def menu_interne_pins():
    global lesPins, win
    win = Toplevel(top)
    win.title('Setting Pins')
    aff  = []
    for i in range(4):
        aff.append( c.w[i].alphabet )
    lesPins = []
    for i in range(4):
        lesPins.append( [] )
        for j in range( len( aff[i] ) ):
            indice = i*100 + j
            aPins = c.w[i].getAPins(aff[i][j])
            if aPins:
                leRelief = 'flat'
            else:
                leRelief = 'sunken'
            l = Label(win, text=aff[i][j], relief= leRelief, \
                font=('Courier'))
            l.grid(row=i, column=j, sticky=NSEW)
            l.bind('<ButtonRelease>', reflexe_pins )
            lesPins[i].append( l )
    Button(win, text='  OK  ', command=ok_pins).grid(columnspan=10, \
        sticky=W)

#---------------------------------------------------------
def reflexe_pins(evt):
    relief = (evt.widget).cget('relief')
    if relief == 'flat':
        (evt.widget).configure(relief='sunken')
    else:
        (evt.widget).configure(relief='flat')

#---------------------------------------------------------
def menu_interne_plugs():
    global win3, lesPlugsC, lesPlugsV
    win3 = Toplevel(top)
    win3.title('Setting Plugs')
    alphaC = c.plug_con.alpha
    plugboardC = c.plug_con.plugboard
    lesPlugsC = []
    for i in range(5):
        lesPlugsC.append( [] )
        l = Label(win3, text=' '+alphaC[i]+' ', font=('Courier'))
        l.grid(row=i, column=0, sticky=NSEW)
        for j in range(5):
            if plugboardC[i] == j :
                leRelief = 'flat'    
                leText=' O '
            else:
                leRelief = 'sunken'    
                leText='   '
            l = Label(win3, text=leText, relief=leRelief, font=('Courier'))
            l.grid(row=i, column=j+1, sticky=NSEW)
            l.bind('<ButtonRelease>', reflexe_plug)
            lesPlugsC[i].append( l )
    alphaV = c.plug_vow.alpha
    plugboardV = c.plug_vow.plugboard
    lesPlugsV = []
    for i in range(5):
        lesPlugsV.append( [] )
        l = Label(win3, text=' '+alphaV[i]+' ', font=('Courier'))
        l.grid(row=i, column=6, sticky=NSEW)
        for j in range(5):
            if plugboardV[i] == j :
                leRelief = 'flat'    
                leText=' O '
            else:
                leRelief = 'sunken'
                leText = '   '
            l = Label(win3, text=leText, relief=leRelief, font=('Courier'))
            l.grid(row=i, column=j+7, sticky=NSEW)
            l.bind('<ButtonRelease>', reflexe_plug)
            lesPlugsV[i].append( l )
    Button(win3,text=' OK ',command=ok_plugs).grid( \
        columnspan=10, row=5, sticky=W)
    #Button(win3,text='Free',command=toto).grid( \
    #    columnspan=10, row=5, sticky=E)

def ok_plugs():
    global lesPlugsC, lesPlugsV, win3, keymodified
    alphaC = c.plug_con.alpha
    flag = 0
    toutPlug = [0,0,0,0,0]
    for i in range(5):
        n = 0
        for j in range(5):
            relief = lesPlugsC[i][j].cget('relief')
            if relief == 'flat':
                c.plug_con.setOnePlug(alphaC[i],alphaC[j])
                n += 1
                toutPlug[ j ] += 1
        if n != 1 : flag = 1
    for j in range(5):
        if toutPlug[j] != 1 : flag = 1
    alphaV = c.plug_vow.alpha
    toutPlug = [0,0,0,0,0]
    for i in range(5):
        n = 0
        for j in range(5):
            relief = lesPlugsV[i][j].cget('relief')
            if relief == 'flat':
                c.plug_vow.setOnePlug(alphaV[i],alphaV[j])
                n += 1
                toutPlug[ j ] += 1
        if n != 1 : flag = 1
    for j in range(5):
        if toutPlug[j] != 1 : flag = 1
    if flag == 1:
        showinfo("Attention!", "All plugs must be used but only once")
        win3.focus_set()
    else:
        print c.plug_con.plugboard, c.plug_vow.plugboard
        keymodified = 1
        win3.destroy()

#---------------------------------------------------------
def reflexe_plug(evt):
    relief = (evt.widget).cget('relief')
    if relief == 'flat':
        (evt.widget).configure(relief='sunken', text='   ')
    else:
        (evt.widget).configure(relief='flat', text=' O ')
    
#---------------------------------------------------------
def menu_nouveau():
    global cpt
    c.zero()
    cpt = 0
    menu_detache()
    majAffichage()

#---------------------------------------------------------
def menu_ouvrir():
    nomFichier = askopenfilename(defaultextension="key", filetypes=\
        [('Key file','.key')])
    if ( nomFichier == ""): return
    if ( nomFichier != None ):
        restore(nomFichier) 

#---------------------------------------------------------
def menu_sauver():
    if nomFichier != None:
        save(nomFichier)
    else:
        menu_sauve_comme()

#---------------------------------------------------------
def menu_sauve_comme():
    global nomFichier
    nomFichier = asksaveasfilename(defaultextension="key", filetypes=\
        [('Key file','.key')])
    if ( nomFichier == ""): return
    if ( nomFichier != None ):
        save(nomFichier)

#---------------------------------------------------------
def menu_quit():
    if keymodified:
        ch = askokcancel('Quit',"Are you sure (the configuration was modified) ?")
        if ch:
            sys.exit(0)
        else:
            return
    sys.exit(0)

#---------------------------------------------------------
def menu_newkey():
    ch = c.plug_vow.getAlpha()
    lst = list(ch)
    random.shuffle(lst)
    ch = "".join(lst)
    c.plug_vow.setAllPlugs( ch )
    ch = c.plug_con.getAlpha()
    lst = list(ch)
    random.shuffle(lst)
    ch = "".join(lst)
    c.plug_con.setAllPlugs( ch )
    for i in range(4):
        alpha = c.w[i].alphabet
        for j in range(len(alpha)):
            if random.randint(0,1):
                c.w[i].setPinsON(alpha[j])
            else:
                c.w[i].setPinsOFF(alpha[j])

#---------------------------------------------------------
def menu_printkey():
    ch = ""
    ch += c.plug_vow.getAllPlugs() + ":"
    ch += c.plug_con.getAllPlugs() + "\n"
    for i in range(4):
        ch += c.w[i].getInternalKey() + "\n"
    win = Toplevel(top)
    win.title('Printable Key')
    l = Label(win, text=ch, font=('Courier'), bg='wheat', justify='left')
    l.pack()
    Button(win, text='Copy to clipboard', command=lambda lab=l: \
        lcopier(lab)).pack()

def menu_bande():
    win2 = Toplevel(top)
    win2.title('Cipher/Decipher')
    st1 = Label(win2, text=textesaisie, bg='white', font=('Courier'))
    st1.pack()
    st2 = Label(win2, text=texteresultat, bg='white', font=('Courier'))
    st2.pack()
    Button(win2, text='copy input (top) to the clipboard', \
        command=lambda lab=st1: lcopier(lab)).pack()
    Button(win2, text='copy output (bottom) to the clipboard', \
        command=lambda lab=st2: lcopier(lab)).pack()
    win2.protocol('WM_DELETE_WINDOW', win2.destroy)

def menu_espace():
    global textesaisie, texteresultat
    textesaisie += "  "
    texteresultat += "  "

def menu_detache():
    global textesaisie, texteresultat, cpt
    textesaisie = ""
    texteresultat = ""
    cpt = 0
    compteur.configure(text=str("%04d" % (cpt)))

def menu_histo():
    ch = c.getHistory()
    win = Toplevel(top)
    win.title('History')
    st = ScrolledText( parent=win, text=ch )
    win.protocol('WM_DELETE_WINDOW', win.destroy )

def menu_retour():
    global cpt
    while cpt > 0:
        cpt -= 1
        c.goBack()
    c.resetHistory()
    majAffichage()

def menu_zero():
    global cpt
    cpt = 0
    c.rot_vow.setKey( "A" )
    c.rot_con.setKey( "A" )
    for i in range(4):
        c.w[i].setKey("A")
    c.resetHistory()
    majAffichage()

def menu_cipher():
    ch = compteur.selection_get(selection="CLIPBOARD")
    ch = ch.upper()
    alpha = c.keyboard.alpha
    for j in range(len(ch)):
        if  string.find(alpha, ch[j] ) == -1:
            continue
        chiffre_une( ch[j] )
    majAffichage()

#---------------------------------------------------------
def menu_properties():
    showinfo("Information", \
            "B21\n" +  \
            "---------------------------------------\n" + \
            "V 0.4, JF Bouchaudy, Licence GPL       \n" + \
            "---------------------------------------\n" + \
            "Simulator of Hagelin B21 cipher machine\n" + \
            "---------------------------------------\n" + \
            "Email: jfbouch@wanadoo.fr              ")
#---------------------------------------------------------
def menu_basic_key():
    basic_key = "Keyboard Grid:\n"
    f = open("rotors/" + cle_base + ".key")
    ch = f.readline().strip()
    for i in range(5):
        basic_key += "   " + ch[i*5:i*5+5] + "\n"
    ch = f.readline().strip()
    basic_key += "Plugboards:\n"
    ch = f.readline().strip()
    basic_key += "   " + ch[0:6]
    ch = f.readline().strip()
    basic_key += ch[0:6] + "\n"
    f.close()
    f = open("rotors/" + cle_rotv + ".rot")
    ligsV = f.readlines()
    f.close()
    f = open("rotors/" + cle_rotc + ".rot")
    ligsC = f.readlines()
    f.close()
    basic_key += "Vowel Rotor:  Consonnant Rotor:\n"
    basic_key += "   " + ligsV[0].strip() + " " + ligsC[0]
    for i in range(1,len(ligsV)):
        basic_key += "   " + ligsV[i].strip() + "      " + ligsC[i]
    win = Toplevel(top)
    win.title('Basic Key')
    l = Label(win, text=basic_key, font=('Courier'), bg='yellow', justify='left')
    l.pack()
    Button(win, text='Copy to clipboard', command=lambda lab=l: \
        lcopier(lab)).pack()
#---------------------------------------------------------
def menu_debug():
    c.toggleDebug()
    #c.DEBUG=1
#---------------------------------------------------------
def menu_save_histo():
    ch = askokcancel('Save histo', \
        "Do you want to copy history in the clipboard ?")
    if ch:
        top.clipboard_clear()
        top.clipboard_append( c.getHistory())
  
#---------------------------------------------------------
def menu_help():
    aide_file = "b21_help.pdf"
    if   platform.system() == "Windows":
        os.startfile( aide_file )
    elif platform.system() == "Linux":
        subprocess.call(["xdg-open", aide_file] )
    else:
        showinfo('Help',"Read the file " + aide_file)

#---------------------------------------------------------
#================ Debut du programme =====================
# 0. Initialisation de la machine a chiffrer
f = open("rotors/modele")
modele = f.readline().strip()
f.close()
f = open("rotors/" + modele + ".modele")
cle_base = f.readline().strip()
cle_rotv = f.readline().strip()
cle_rotc = f.readline().strip()
f.close()
c = cl_b21.B_21(cle_base, cle_rotv, cle_rotc,0 )
alphabet = c.lights_and_keys
mode_cd="C"
mode_ar="A"
mode_pl=False
cpt = 0
textesaisie = ""
texteresultat = ""
keymodified =  0
nomFichier = None

#---------------------------------------------------------
# 1. Initialisation des var. glob. et Creation des widgets
coord_touche = {}
coord_lampe = {}
clavier_rond  = {}
clavier_text  = {}
lampe = {}
une_touche_enfoncee = 0
lettre_crypto = 'A'

top = Tk()
ecran = Canvas(width=500,heigh=500)
photo = PhotoImage(file='b-21.gif')
ecran.create_image(250,250, image = photo )
ecran.pack(expand=YES, fill=BOTH)

#---------------------------------------------------------
# 2. On dessine les touches
#a = "QWERTYUIOPASDFGHJKLXCVBNM"
a = alphabet
coord_touche = {
  a[ 0]:[100,375],a[ 1]:[135,375],a[ 2]:[170,375],a[ 3]:[205,375],
  a[ 4]:[240,375],a[ 5]:[275,375],a[ 6]:[310,375],a[ 7]:[345,375],
  a[ 8]:[380,375],a[ 9]:[415,375],a[10]:[125,410],a[11]:[160,410],
  a[12]:[195,410],a[13]:[230,410],a[14]:[265,410],a[15]:[300,410],
  a[16]:[335,410],a[17]:[370,410],a[18]:[405,410],a[19]:[170,445],
  a[20]:[205,445],a[21]:[240,445],a[22]:[275,445],a[23]:[310,445],
  a[24]:[345,445]
}

for lettre in list(a):
    dessine_touche( lettre, coord_touche[lettre] )

#---------------------------------------------------------
# 3. On dessine les lampes
a = alphabet
coord_lampe = {
  a[ 0]:[100,225],a[ 1]:[135,225],a[ 2]:[170,225],a[ 3]:[205,225],
  a[ 4]:[240,225],a[ 5]:[275,225],a[ 6]:[310,225],a[ 7]:[345,225],
  a[ 8]:[380,225],a[ 9]:[415,225],a[10]:[125,260],a[11]:[160,260],
  a[12]:[195,260],a[13]:[230,260],a[14]:[265,260],a[15]:[300,260],
  a[16]:[335,260],a[17]:[370,260],a[18]:[405,260],a[19]:[170,295],
  a[20]:[205,295],a[21]:[240,295],a[22]:[275,295],a[23]:[310,295],
  a[24]:[345,295]
}
for lettre in list(a):
    dessine_lampe( lettre, coord_lampe[lettre] )

coord_bouton = {
  'A':[15,150],'B':[70,125],'C':[170,125],'D':[190,125],
  'E':[290,125],'F':[70,25],'G':[215,25], 'H':[355,125],'I':[15,125]
}
for x in list("BCDEFG"):
    dessine_bouton(x, coord_bouton[x],50)
dessine_bouton('A', coord_bouton['A'],25)
dessine_bouton('I', coord_bouton['I'],25)

#---------------------------------------------------------
# 4. Creer les autres elements graphiques
cleHRgauche = Label(ecran,text='A',bg='white')
cleHRdroite = Label(ecran,text='A',bg='white')
cleWheel = []
cleWheel.append( Label(ecran,text='A',bg='white') )
cleWheel.append( Label(ecran,text='A',bg='white') )
cleWheel.append( Label(ecran,text='A',bg='white') )
cleWheel.append( Label(ecran,text='A',bg='white') )
compteur = Label( ecran, text='0000', bg='black', fg='white' )
modecd =  Button( ecran, text="C", bg='grey', command=modeChiffre )
modear =  Button( ecran, text="A", bg='grey', command=modeAvant )
ecran.create_window(100,50,window=cleHRgauche)
ecran.create_window(200,50,window=cleHRdroite)
for i in range(4):
    ecran.create_window(100+i*60,150,window=cleWheel[i])
ecran.create_window(350,80,window=compteur)
ecran.create_window(25,50,window=modecd)
ecran.create_window(25,250,window=modear)

#---------------------------------------------------------
# 5. Gestion des menus
pereMenu = Menu(top)
top.config(menu=pereMenu)
file= Menu(pereMenu, tearoff=0)
file.add_command(label='New', command=menu_nouveau, underline=0)
file.add_command(label='Open',command=menu_ouvrir, underline=0)
file.add_command(label='Save', command=menu_sauver, underline=0)
file.add_command(label='Save Key File as', command=menu_sauve_comme, underline=7)
file.add_separator()
file.add_command(label='Exit', command=menu_quit, underline=0)
sett= Menu(pereMenu, tearoff=0)
sett.add_command(label='Zeroizing', command=menu_nouveau, underline=0)
sett.add_separator()
sett.add_command(label='Setting key wheel pins', command=menu_interne_pins, underline=0)
sett.add_command(label='Setting key Plugs', command=menu_interne_plugs, underline=0)
sett.add_command(label='Print basic key', command=menu_basic_key, underline=0)
sett.add_separator()
sett.add_command(label='Generate New key', command=menu_newkey, underline=0)
sett.add_command(label='Print internal Key', command=menu_printkey, underline=0)
affi= Menu(pereMenu, tearoff=0)
affi.add_command(label='Tapes', command=menu_bande, underline=0)
affi.add_command(label='Advance tapes', command=menu_espace, underline=0)
affi.add_command(label='Cut tapes', command=menu_detache, underline=0)
affi.add_separator()
affi.add_checkbutton(label='Debug', command=menu_debug, underline=0)
affi.add_separator()
affi.add_command(label='History', command=menu_histo, underline=0)
affi.add_command(label='Save History', command=menu_save_histo, underline=0)
extk= Menu(pereMenu, tearoff=0)
extk.add_command(label='Ready to check (AAAAAA)', command=menu_zero, underline=0)
extk.add_command(label='Come-back (Counter:0000)', command=menu_retour, underline=0)
extk.add_separator()
extk.add_command(label='To cipher from clipboard', command=menu_cipher, underline=0)
hlpm= Menu(pereMenu, tearoff=0)
hlpm.add_command(label='Help', command=menu_help, underline=0)
hlpm.add_separator()
hlpm.add_command(label='About ...', command=menu_properties, underline=0)
pereMenu.add_cascade(label='File', menu=file, underline=0)
pereMenu.add_cascade(label='Internal Key', menu=sett, underline=0)
pereMenu.add_cascade(label='Display', menu=affi, underline=0)
pereMenu.add_cascade(label='External Key', menu=extk, underline=0)
pereMenu.add_cascade(label='?', menu=hlpm, underline=0)
top.bind("<KeyPress>", onKeyPress)
top.protocol("WM_DELETE_WINDOW",menu_quit)

#---------------------------------------------------------
# 6. Gerer les evts
top.bind("<Any-KeyPress>",onKeyPress)
top.bind("<Any-KeyRelease>",onKeyRelease)

#---------------------------------------------------------
top.mainloop()

