# B21a_text.py

import sys
import string
import cl_b21

#========== Debut Programme
if len(sys.argv)<2:
    print "B-21.py Syntaxe:"
    print "b21.py key_base half_rot_vowel half_rot_con key_msg C|D"
    sys.exit(0)
if len(sys.argv)<7:
    DEBUG=0
else:
    DEBUG=1
KEY_BASE  = sys.argv[1]
KEY_HRVO  = sys.argv[2]
KEY_HRCO  = sys.argv[3]
KEY_MESG  = sys.argv[4]
if ( sys.argv[5] == "C" ):
    MODE_CIPHER = 1
else:
    MODE_CIPHER = 0

cryptogramme = ""
for ligne in sys.stdin:
    ligne = string.upper(ligne)
    cryptogramme = cryptogramme + ligne

c = cl_b21.B_21(KEY_BASE,KEY_HRVO,KEY_HRCO, DEBUG )
c.setKey( KEY_MESG )  
if ( DEBUG ): c.info()


ch = ""
for i in range(len(cryptogramme)):
    try:
        x = string.index(string.ascii_uppercase, cryptogramme[i])
        if ( MODE_CIPHER ):
            ch = ch + c.cipher( cryptogramme[i] )
        else:
            ch = ch + c.decipher( cryptogramme[i] )
    except:
        continue
print ch
